package com.itbaizhan.dao.impl;

import com.itbaizhan.common.JdbcDruidUtils;
import com.itbaizhan.dao.UsersDao;
import com.itbaizhan.exception.ApplicationException;
import com.itbaizhan.pojo.Users;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

public class UsersDaoImpl implements UsersDao {
    /**
     * 根据用户id查询用户
     * @param userid
     * @return
     */
    @Override
    public Users selectUsersById(int userid) {
        Connection connection = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        Users users = null;
        try {
            connection = JdbcDruidUtils.getConnection();
            ps = connection.prepareStatement("select * form Users where userid=?");
            ps.setInt(1,userid);
            rs = ps.executeQuery();
            while (rs.next()){
                //手动orm映射
                users  = new Users();
                users.setUserid(rs.getInt("userid"));
                users.setUsername(rs.getString("username"));
                users.setUserage(rs.getInt("userage"));
            }
        }catch (Exception e){
            e.printStackTrace();
            //通过自定义异常解决异常耦合问题
            throw new ApplicationException(e.getMessage());
        }finally {
            JdbcDruidUtils.closeResource(rs,ps,connection);
        }

        return users;
    }
}
